﻿
# Rinne にボイスチェンジしたい

[RVC](https://github.com/liujing04/Retrieval-based-Voice-Conversion-WebUI) と [VC Client](https://github.com/w-okada/voice-changer) によるボイスチェンジャーで Rinne の声になれます。

## つかいかた

1. `VoiceChange.bat` をダブルクリックします。
	- 赤字のエラーが表示されていたら、新しいVC Clientがリリースされている可能性があります。
		- `VoiceChange.bat` の `set ZIP_FILE=` 以降のバージョン番号を[公式ページ](https://huggingface.co/wok000/vcclient/tree/main)に合わせると動作する可能性があります。
2. インストールが完了すると、ブラウザとアプリで「Realtime Voice Changer Client」が立ち上がります。
	- Windows Defenderファイアーウォールが通信をブロックしたら「アクセスを許可する」とします。
		- コンソールにエラーが表示されていたら、一旦閉じて Run.bat を再起動します。
	- アプリの「Voice Changer Client Demo」は最小化しておきます。
		- アプリを閉じてしまうとボイスチェンジができなくなります。
		- アプリからのボイスチェンジでは、なぜかうまく声を変換できません。
3. 次の VoiceChange.png と比較しながら、**アプリでなくブラウザ側**を設定します。
	- ブラウザからマイクへのアクセスを求められたら、許可します。
4. ブラウザで「Model Setting」の「Model Uploader」で同梱のRinneモデル4種を「select」して「upload」します。
	- Onnx(.onnx): Rinne.onnx
	- PyTorch(.pth): Rinne.pth
	- feature(.npy): Rinne.npy
	- index(.index): Rinne.index
	- 最後に忘れずに「upload」すると、「Server Control」の「Model Info」が更新されます。
		- アップロードが途中で止まる場合は、一旦終了して Run.bat を再起動してください。
5. 変換前に各種設定をします。
	- 「Device Setting」で「Audio Input」と「Audio Output」を、お使いのサウンドデバイスに設定します。
	- 変換する声が女性の場合は「Speaker Setting」の「Tuning」を「0」にします。
	- 「Speaker Setting」の「predict f0」を有効にします。
6. 一番上の「Server Control」の「start」で、マイクからの声をリアルタイムで変換できます。
![VoiceChange](./VoiceChange.png)
7. 変換する声に合わせて以下を調整します。
	- 「Speaker Setting」の「Tuning」を男性なら「10～20」、女性なら「-5～5」など
	- マイクのノイズが大きい場合は「Speaker Setting」の「Silent Threshold」を上げる
	- 「Converter Setting」の「Input Chunk Num」で音声の遅延調整
	- 「Quality Control」の「F0 Detector」を「harvest」と「dio/pm」で切り替え
8. 「Device Setting」の「output record」で「start」すると録音できます。

## Discord でつかうには

以下を参考にしてください。

https://overwhelmingrowth.com/entry/2023/04/09/232415#VB-Audio-Virtual-Cable%E3%81%AE%E5%B0%8E%E5%85%A5

[戻る](./README.md)
